﻿/*
 * MAPA SMS
 * Serviços customizados para envio de SMS
 * Solicite um teste: suporte@mapainformatica.com.br
 * by Slex - slex@slex.com.br
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Web;
using System.Net;
using System.IO;
using System.Windows.Forms;
using Microsoft.Win32;

namespace WinFormAppSMSMapa
{
    public partial class Form1 : Form
    {
        private string urlsms = "http://sms.mapainformatica.com.br/";

        private string _post(string url, string postdata)
        {
            HttpWebResponse resp;
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
            req.UserAgent = "Mozilla/5.0";
            req.AllowAutoRedirect = true;
            req.Method = "POST";
            req.ReadWriteTimeout = 5000;

            req.SendChunked = false;
            req.Referer = "";
            req.ContentLength = postdata.Length;
            req.Headers.Set("Accept-Language", "en,en-us");
            StreamReader stream_in;
            StreamWriter stream_out = new StreamWriter(req.GetRequestStream(), System.Text.Encoding.ASCII);
            stream_out.Write(postdata);
            stream_out.Close();
            resp = (HttpWebResponse)req.GetResponse();

            stream_in = new StreamReader(resp.GetResponseStream());
            string response = stream_in.ReadToEnd();
            stream_in.Close();
            return response;
        }

        private string getUrlEncodeParam(string param, string paramName, bool obrigatorio = false, string defaultValue = "")
        {
            if (param == null)
            {
                if (obrigatorio)
                {
                    throw new Exception("Parâmetro Obrigatório: " + paramName);
                }
                return defaultValue;
            }
            return HttpUtility.UrlEncode(param.ToString());
        }

        private string setSms(string chave, string Telefone, string Texto) {
            string param = "auth=" + chave;
            param += "&mobile=" + this.getUrlEncodeParam(Telefone, "Telefone", true);
            param += "&content=" + this.getUrlEncodeParam(Texto, "Texto", true);
            string htmlresp = this._post(
                    urlsms + "send",
                    param
            );
            return htmlresp;
        }

        private string getSaldoMes(string chave)
        {
            string param = "auth=" + chave;
            string htmlresp = this._post(
                    urlsms + "balance",
                    param
            );
            return htmlresp;
        }


        public Form1()
        {
            InitializeComponent();
        }

        private void btnLImpar_Click(object sender, EventArgs e)
        {
            textLog.Text = "";
        }


        private void btnEnviar_Click(object sender, EventArgs e)
        {
              textLog.Text = setSms(
                  EditCHAVE.Text,
                  EditTelefone.Text,
                  MemoSMS.Text
              );
        }

        private void btnSaldo_Click(object sender, EventArgs e)
        {
            textLog.Text = getSaldoMes(
                  EditCHAVE.Text
              ).Replace("\n","\r\n").Trim();
        }
    }
}
